Module jdk.httpserver
Package com.sun.net.httpserver

## Class BasicAuthenticator

- java.lang.Object
- - com.sun.net.httpserver.Authenticator
  - - com.sun.net.httpserver.BasicAuthenticator

-     public abstract class BasicAuthenticator
      extends Authenticator

  BasicAuthenticator provides an implementation of HTTP Basic authentication. It is an abstract class and must be extended to provide an implementation of `checkCredentials(String,String)` which is called to verify each incoming request.

- - ### Nested Class Summary

    - ### Nested classes/interfaces declared in class com.sun.net.httpserver.Authenticator

      `Authenticator.Failure, Authenticator.Result, Authenticator.Retry, Authenticator.Success`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected String` | `realm` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BasicAuthenticator​(String realm)` | Creates a BasicAuthenticator for the given HTTP realm

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract boolean` | `checkCredentials​(String username, String password)` | called for each incoming request to verify the given name and password in the context of this Authenticator's realm.
    `String` | `getRealm()` | returns the realm this BasicAuthenticator was created with

    - ### Methods declared in class com.sun.net.httpserver.Authenticator

      `authenticate`

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### realm

          protected String realm

  - ### Constructor Detail

    - #### BasicAuthenticator

          public BasicAuthenticator​(String realm)

      Creates a BasicAuthenticator for the given HTTP realm
      Parameters:
        `realm` - The HTTP Basic authentication realm
      Throws:
        `NullPointerException` - if the realm is an empty string

  - ### Method Detail

    - #### getRealm

          public String getRealm()

      returns the realm this BasicAuthenticator was created with
      Returns:
        the authenticator's realm string.

    - #### checkCredentials

          public abstract boolean checkCredentials​(String username,
                                                   String password)

      called for each incoming request to verify the given name and password in the context of this Authenticator's realm. Any caching of credentials must be done by the implementation of this method
      Parameters:
        `username` - the username from the request
        `password` - the password from the request
      Returns:
        `true` if the credentials are valid, `false` otherwise.